//headers of all used functions

//num_rec.c 
int tqli(float d[], float e[], int n, float **z);
void tred2(float **a, int n, float d[], float e[]);
float pythag(float a, float b);
float ran2(long *idum);

//acn_funk_lb
void zacPriblUF(long seed);
void calcF2Ul(int l, float **f);
void calcFNEW2F();
void fillHl(int l,float (*h)[4]);
void izrSStressL(int l, float (*sigl)[4], float (*qlm)[4], float *ul, float *dx, float *dy, float *dz);
void izrAStressL(int l,float (*tau)[4]);
void izrOdvAStressL(int l,float *divTaul);
void izrFeq(float **feq);
void izrP();
void fillUl2(int l, float* Ul2);
int calcLBlnew(int l, int m);
int calcLBmnew(int m);
int calcLBmnew_noslipZ(int m);
int calcm2mrot(int m, int faktor);
int calcLpbc(int l);
void pbcLB();
void izrCasKorU();
void izrQU();
void compute_stress_tensor();

//acn_funk_op.c
void zacPriblQ(long seed);
void dir2QRP(int l, float dirX, float dirY, float dirZ, float nX, float nY, float nZ, float vX, float vY, float vZ, char lmark, long seed);
void dir2QBulk(int l,long seed);
void izrOdvQ2(int l, float* dxx, float* dyy, float* dzz, float* dx, float* dy, float* dz);
// void izrOdvQ2_fe(int l, float* dxx, float* dyy, float* dzz, float* dxy, float* dxz, float* dyz, float* dx, float* dy, float* dz);
void izrOdvQ2POV(int l, float* dx, float* dy, float* dz);
double calculate_free_energy();
void izrOdvQ2_lb(int l, float* dxx, float* dyy, float* dzz, float* dx, float* dy, float* dz);
void izrOdvU2(int l, float *ux, float *uy, float *uz);
void fillQl2(int l, float* ql);
void fillQlm2(int l, float (*qlm)[4]);
void calcU1(int l,float *u1, float* dxx, float* dyy, float* dzz, float* dx, float* dy, float* dz, float* ql);
void calcU2(float *u2, float *ux, float *uy, float *uz, float (*qlm)[4]);
void calcU3(float *u3, float* dx, float* dy, float* dz, float* ul);
void izrCasKorQ();
void calcQNEW2Q();

//acn_utils.c
int i_vr(int l);
int j_vr(int l);
int k_vr(int l);
void initialiseE();
void AMatrixB(float (*c)[4], float (*a)[4],float (*b)[4]);

//acn_funk_zapis.c
void zapisQ(char *ime);
void zapisTEN(char *ime,float **q, int lmax, int mmax);
void beriDATA(char *ime);
void zapisDATA(char *ime);
void za_profilU(char *ime, int i, int j);
void zapisUraw(char *ime);
void zapisDENraw(char *ime);
void calcQ2dirL(int l,float *dir);
void zapisQ2DIRraw(char *ime);
void zapisQ2OPraw(char *ime);
void zapisPOLJEraw(int t,char *ime);
//acn_funk_pe.c


//acn_funk_kol.c

//active droplet
struct active_droplet{
    
    int num_points;  // number of lattice points on sphere
    int* association;
    double* lattice_thetas;
    double* lattice_phis;
    double* velocities;
    double defect_config[13];

};

typedef struct active_droplet ActiveDroplet;




// //active droplet
// void propagate_trajectories_block(double* variables, double nu, double chi, double xi_rot, double xi_alpha,
//   double dt, int num_steps);
// void velocity_field(double* defect_config, int n, double* lattice_thetas, double* lattice_phis,
//   double rho, double* velocities);
